{
  Dados os conjuntos X e Y, com N elementos cada um, e um valor Z, localize a
  posicao de Z no conjunto X. Se Z for igual a algum Xi, exiba o valor de Z e
  de Yi. Caso contrario exiba a mensagem 'Z esta fora do conjunto X'.
}

program LocalizaValor;
(* Le os conjuntos X e Y e um valor Z; localiza a posicao de Z no conjunto *)
(* X, e exibe o valor da posicao correspondente de Y.                      *)

const
   MAX_N = 50;
type
   tArranjo = array [1..MAX_N] of real;
var
   X, Y : tArranjo;
   Z : real;
   N, i : integer;
   encontrouZ : boolean;

procedure Leitura(var a : tArranjo);
(* Le os elementos de um conjunto (arranjo) *)

var
   i : integer;

begin
   for i := 1 to N do
       readln(a[i]);
end;

begin
   (* Leitura do numero de elementos dos conjuntos X e Y *)
   writeln('Introduza o numero de elementos dos conjuntos :');
   readln(N);

   while (N > MAX_N) do begin  (* Testa se o numero de elementos eh valido *)
       writeln('O maior numero de elementos admissivel eh ',MAX_N,'.');
       writeln('Introduza outro numero :');
       readln(N);
   end;

   (* Leitura dos elementos de X *)
   writeln('Introduza os elementos de X (um por linha) :');
   Leitura(X);

   (* Leitura dos elementos de Y *)
   writeln('Introduza os elementos de Y (um por linha) :');
   Leitura(Y);

   (* Leitura do numero a ser procurado *)
   writeln('Introduza um numero qualquer :');
   read(Z);

   encontrouZ := false;  (* Testa se o numero introduzido foi localizado *)
   for i := 1 to N do begin
       if (Z = X[i]) then begin
           writeln('O valor de Z eh ',Z:9:3,' e seu valor correspondente em Y eh : ',Y[i]:9:3);
           encontrouZ := true;
       end;
   end;
   if (not encontrouZ) then
       writeln('Z esta fora do conjunto.');
end.