{
  Fazer um programa em PASCAL que:
  a) leia duas variaveis indexadas unidimensionais, contendo, cada uma, 25
     elementos numericos;
  b) intercale os elementos destes dois conjuntos formando uma nova variavel
     indexada unidimensional de 50 elementos;
  c) exiba o novo conjunto, assim obtido.
}

program IntercalaElementos;
(* Intercala os elementos de dois arranjos, originando um novo arranjo *)

const
   S = 25;
type
   tArranjo = array [1..S] of real;
   tArranjoIntercalado = array [1..2*S] of real;
var
   primeiroArranjo, segundoArranjo : tArranjo;
   arranjoResultante : tArranjoIntercalado;
   i, numeroDeElementos : integer;

procedure Leitura(var arranjoQualquer : tArranjo; quantidade : integer);
(* Este procedimento le um arranjo de varios elementos *)

begin
   for i := 1 to quantidade do
       read(arranjoQualquer[i]);
end; (* Leitura *)

begin
   writeln('Digite um valor menor do que ou igual a ',S,', representando o numero de elementos dos conjuntos : ');
   readln(numeroDeElementos);

   while (numeroDeElementos > S) do begin
       writeln('Erro. O valor eh maior do que ',S,'. Introduza-o novamente : ');
       readln(numeroDeElementos);
   end; (* while *)

   (* Leitura dos dois arranjos *)

   writeln('Introduza os elementos do primeiro conjunto : ');
   Leitura(primeiroArranjo,numeroDeElementos);

   writeln('Introduza os elementos do segundo conjunto : ');
   Leitura(segundoArranjo,numerodeElementos);

   for i := 1 to numeroDeElementos do begin
       (* Os elementos cujo indice eh impar provem do primeiroArranjo *)
       arranjoResultante[2*i - 1] := primeiroArranjo[i];
       (* Os elementos cujo indice eh par provem do segundoArranjo *)
       arranjoResultante[2*i] := segundoArranjo[i];
   end; (* for *)

   (* Imprime o conjunto resultante da intercalacao *)
   writeln('O conjunto obtido da intercalacao eh : ');
   for i := 1 to (2 * numeroDeElementos) do
       writeln(arranjoResultante[i]:7:3);
end.