{
  Escreva uma funcao que receba duas cadeias de caracteres e procure, na
  primeira, uma ocrrencia da segunda cadeia de caracteres, retomando a
  posicao do primeiro caracter, ou 0, caso nao exista.
}

program VerificaOcorrenciaDeUmString;
(* Dada duas cadeias de caracteres, este programa procura a ocorrencia da  *)
(* segunda cadeia na primeira, imprimindo o indice do primeiro caracter ou *)
(* 0, caso nao haja ocorrencia                                             *)

const
   MAX_CARACT = 255;
type
   tString = string[MAX_CARACT];
var
   stringFonte, stringProcurado : tString;
   ocorre : integer;

function RetornaPrimeiraOcorrencia(stringMaior, substring : tString) : integer;
(* Dada duas cadeias de caracteres, esta funcao procura a ocorrencia da    *)
(* segunda cadeia na primeira, retornando o indice do primeiro caracter ou *)
(* 0, caso nao haja ocorrencia                                             *)

var
   i, j, k, indice : integer;
   pertence, indiceValido : boolean;

begin
   i := 1;       (* Inicializa a variavel com 1 *)
   indice := 0;       (* Inicializa a variavel com 0 *)
   indiceValido := false;  (* Inicializa a variavel com FALSE *)

   repeat begin
       if (stringMaior[i] = substring[1]) then begin
           k := i + 1;
           pertence := true;
           for j := 2 to length(substring) do begin
               if (substring[j] <> stringMaior[k]) then
                   pertence := false;
               k := k + 1;
           end;

           (* Se a segunda cadeia esta contida na primeira, "indice"      *)
           (* recebe o indice do primeiro caracter da cadeia encontrado e *)
           (* "indiceValido" recebe TRUE, ou seja, o indice recebe um     *)
           (* valor valido                                                *)
           if pertence then begin
               indice := i;
               indiceValido := true;
           end
           else
           (* Se um caracter da primeira cadeia eh igual ao primeiro caracter   *)
           (* da segunda, mas os demais nao equivalem aos caracteres restantes  *)
           (* da segunda, verifica-se se ele eh o ultimo da primeira. Em caso   *)
           (* afirmativo "indice" recebe o valor 0 e "indiceValido" recebe TRUE,*)
           (* ou seja, o indice recebe um valor valido. Caso contrario volta-se *)
           (* para comparar com o restante da cadeia                            *)
               if (i = length(stringMaior)) then begin
                   indice := 0;
                   indiceValido := true;
               end;
       end
       else
       (* Se um caracter da primeira cadeia nao eh igual ao primeiro caracter   *)
       (* da segunda, verifica-se se ele eh o ultimo da primeira. Em caso       *)
       (* afirmativo "indice" recebe o valor 0 e "indiceValido" recebe TRUE, ou *)
       (* seja, o indice recebe um valor valido. Caso contrario volta-se para   *)
       (* comparar com o restante da cadeia                                     *)
           if (i = length(stringMaior)) then begin
               indice := 0;
               indiceValido := true;
           end;

       i := i + 1 (* Incrementa-se o i, para poder comparar o caracter seguinte *)
   end;

   (* O repeat eh encerrado quando o indice recebe um valor valido *)
   until(indiceValido); (* Repeat *)

   RetornaPrimeiraOcorrencia := indice; (* A funcao retorna o indice *)
end; (* RetornaPrimeiraOcorrencia *)

begin
   (* Leitura da primeira cadeia de caracteres *)
   writeln('Digite uma cadeia de caracteres :');
   readln(stringFonte);

   (* Leitura da segunda cadeia de caracteres *)
   writeln('Digite a segunda cadeia de caracteres para verificar se ela ocorre na primeira :');
   readln(stringProcurado);

   (* A variavel "ocorre" recebe o retorno da funcao *)
   ocorre := RetornaPrimeiraOcorrencia(stringFonte,stringProcurado);

   (* Se o retorno for diferente de 0, imprime-se o indice do primeiro *)
   (* caracter. Caso contrario, imprime-se uma mensagem que informa ao *)
   (* usuario que a segunda cadeia nao foi encontrada na primeira      *)
   if (ocorre <> 0) then
       writeln('O string "',stringProcurado,'" ocorre na posicao ',ocorre,' da cadeia : "',stringFonte,'"')
   else
       writeln('O string "',stringProcurado,'" nao ocorre no string : "',stringFonte,'"');
end.