{
  Fazer um programa para calcular a raiz quadrada de um numero positivo ,
  usando o roteiro abaixo, baseado no metodo de aproximacoes sucessivas
  de Newton:
  Seja Y o numero:
        - a primeira aproximacao para a raiz quadrada de Y eh: X = Y/2
        - as sucessivas aproximacoes serao: X = (X*X + Y)/(2*X)
  O programa devera prever 20 aproximacoes
}

program RaizesQuadradas;
(* Este programa calcula a raiz quadrada de um numero real maior ou igual a *)
(* zero, utilizando o metodo de Newton                                      *)

var
   numeroReal,raizQuadrada : real;
   i : integer;

begin
   writeln('Introduza o numero do qual deseja-se a raiz quadrada :');
   read(numeroReal);
   raizQuadrada := 0.0; (* Inicializa a variavel com o valor 0 *)

   if (numeroReal > 0) then begin
       raizQuadrada := numeroReal/2; (* Aproximacao inicial para a raiz quadrada *)

       (* Numero de iteracoes necessarias para se obter a raiz quadrada *)
       (* do numero introduzido                                         *)
       for i := 1 to 20 do

           (*                     Metodo de Newton                        *)
           (* O valor da aproximacao eh modificado a cada entrada no laco *)
           (* obtendo-se assim a raiz quadrada do numero real introduzido *)
           raizQuadrada := (sqr(raizQuadrada) + numeroReal)/(2 * raizQuadrada);

       (* Imprime a raiz quadrada do numero real introduzido *)
       writeln('A raiz quadrada de ',numeroReal:9:3,' eh : ',raizQuadrada:9:3);
   end
   else if (numeroReal < 0) then
            writeln('A raiz quadrada de numeros negativos nao existe.')
        else
            writeln('A raiz quadrada de ',numeroReal:9:3,' eh : ',raizQuadrada:9:3);
end.