{
  Escreva um programa que le um arquivo do tipo texto e o imprime na tela com
  duplo ou triplo espaco entre as palavras. O numero de espacos deve ser
  especificado pelo usuario.
}

program AcrescentaEspacosEmArquivos;
(* Imprime, na tela do computador, o arquivo lido com duplo ou triplo espaco  *)
(* entre as palavras, onde o numero de espacos eh especificado pelo usuario.  *)

const
   BRANCO = ' ';
var
   arquivoIn : text;
   caracter : char;
   i, numEspacos : integer;

begin
   assign(arquivoIn,'a:\arquivo.txt');  (* Associacao da variavel ao arquivo real *)
   reset(arquivoIn);      (* Preparacao do arquivo para leitura *)

   (* Leitura do numero de espacos em branco a serem acrescentados *)
   writeln('Digite o numero de espacos que devem ser impressos entre as palavras do arquivo :');
   readln(numEspacos);

   (* Testa se o numero introduzido eh valido *)
   while ((numEspacos <> 2) and (numEspacos <> 3)) do begin
       writeln('Os numeros de espacos admissiveis sao 2 e 3. Digite 2 ou 3 :');
       readln(numEspacos);
   end;

   (* Impressao do arquivo na tela do computador *)
   while not EOF(arquivoIn) do begin
       while not EOLN(arquivoIn) do begin
           read(arquivoIn,caracter);
           if (caracter <> BRANCO) then       (* Se o caracter lido for diferente  *)
               write(caracter)                (* de BRANCO, o caracter eh apenas   *)
           else begin                         (* impresso na tela. Caso contrario, *)
           		for i := 1 to numEspacos do   (* o caracter BRANCO eh impresso     *)
                    write(BRANCO);            (* 'numEspacos' vezes na tela        *)
           end;
       end;
       readln(arquivoIn);   (* Pula linha no arquivo *)
       writeln;             (* Pula linha na tela *)
   end;

   close(arquivoIn);  (* Fecha o arquivo *)
end.